<?php 
/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */

/**
 * Définition d’une classe.
 */
class Utils
{ 
	// Attribut privé quelconque. 
	private $sValeur; 

	// Attribut privé statique pour stocker le nombre d'objets instanciés. 
	static private $iNombre = 0; 
	static public $iMulti = 10; 
	
	// Constante de classe pour définir une valeur par défaut. 
	const DEFAUT = "NOT_USE"; 
	
	/**
	 * Fonction publique statique qui retourne le nombre d’objets de la classe.
	 * @return [type] [description]
	 */
	static public function getNombreObjects()
	{ 
		return Utils::$iNombre; 
	} 

	/**
	 * Le constructeur
	 *
	 * récupére la valeur de l’attribut (valeur par défaut = la constante de classe) 
	 * incrémente le nombre d’objets 
	 * 
	 */
	public function __construct($valeur = Utils::DEFAUT)
	{ 
		$this->sValeur = $valeur; 
		Utils::$iNombre++; 
		echo "Creation de l'objet : ".$this->sValeur."<br />"; 
	}


	/**
	 * Le destructeur.
	 * Appelé lors de l'utilisation d'un unset (libération de mémoire)
	 * 
	 * décrémente le nombre d’objets 
	 * 
	 */
	public function __destruct()
	{ 
		Utils::$iNombre--; 
		echo "Suppression de l'objet : ".$this->sValeur."<br />"; 
	} 
} 

// Crée 2 objets. 
// 
$oVal1 = new Utils(); 
$oVal2 = new Utils ("Matthieu"); 


// Affiche le nombre d’objets 
echo Utils::getNombreObjects()."objet(s) <br /><br />";

// Supprime un objet. 
unset($oVal1); 

// Affiche le nombre d’objets 
echo Utils::getNombreObjects()."objet(s) <br />"; 
echo Utils::$iMulti."objets par defaut <br /><br />";

?>
